"""
The MIT License (MIT)

Copyright (c) 2017 Guillermo Romero Franco (AKA Gato)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
"""




class Config:
	def __init__(self):
		self._resolution = (1024,768)
		self._framerate = 60
		self._game_name = "bokeh"
		self._resizable = True
		self._play_music = True
		self._trail_fade_speed = 1.0/400
		self._print_fps = False

	@property
	def resolution(self):
		return self._resolution

	@property
	def framerate(self):
		return self._framerate

	@property
	def game_name(self):
		return self._game_name

	@property
	def resizable(self):
		return self._resizable

	@property
	def play_music(self):
		return self._play_music

	@property
	def trail_fade_speed(self):
		return self._trail_fade_speed

	@property
	def print_fps(self):
		return self._print_fps

	@property
	def main_font(self):
		return "Semi-Casual.ttf"

	@property
	def mono_font(self):
		return "Hack-Bold.ttf"

	@property
	def initial_score(self):
		return 10000

	@property
	def user_link_add_points(self):
		return -5

	@property
	def enemy_link_add_points(self):
		return 5

	@property
	def user_link_remove_points(self):
		return 10

	@property
	def enemy_link_remove_points(self):
		return -10

	@property
	def default_music(self):
		return "Lobo_Loco_-_01_-_Oortsche_Wolke_ID_80.mp3"

C = Config()

def init():
	pass
