"""
The MIT License (MIT)

Copyright (c) 2017 Guillermo Romero Franco (AKA Gato)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
"""

from scene import Scene
from button import Button
from config import C
from text import Text
from texture import Texture
from sprite import StaticSprite
from resources import R
from sprite import StaticSprite
from sdl2 import *


class MenuScene(Scene):

	ALL_LEVELS = 1
	RANDOM_LEVEL = 2

	def __init__(self, renderer):
		Scene.__init__(self, renderer)


		self.addButtons([
			"ALL LEVELS",
			"RANDOM LEVEL",
			#"HELP",
			"QUIT",
			])

		StaticSprite(self, pos = (0,0), src="menubg.jpg",scale=1.0,centered=False,z=-100)

	def addButtons(self, buttons,):
		n = len(buttons)
		h = min(n*90, C.resolution[1]-100)
		y = (C.resolution[1]-h)/2
		x = C.resolution[0]/2
		dy = float(h)/n

		background = R.texture("button_bg.png", blend_mode=SDL_BLENDMODE_ADD)

		for i,txt in enumerate(buttons):
			pos = (x,y)
			text = Text(None, C.main_font, text=txt, pos = pos)
			#StaticSprite(self, text.texture(), pos )
			#StaticSprite(self, text.toTexture(), pos )
			Button(self, text.toTexture(), pos, on_click_cb=self.onSelect, cb_data=i, background=background, padding=20, min_size=(270,1), bg_tint=(0.2,0.1,0.1))

			y += dy

	def onSelect(self, button, b_num):
		SDL_Delay(200)
		if b_num == 0: self.switchScene(Scene.MAIN_SCENE, self.ALL_LEVELS)
		if b_num == 1: self.switchScene(Scene.MAIN_SCENE, self.RANDOM_LEVEL)
		#if b_num == 2: self.switchScene(Scene.HELP_SCENE)
		if b_num == 2: self.quitGame()






