"""
The MIT License (MIT)

Copyright (c) 2017 Guillermo Romero Franco (AKA Gato)

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
"""

from entity import Entity

class Timer(Entity):
	def __init__(self, scene, timeout, on_done, cb_data=None, repeat=False):
		Entity.__init__(self, scene)
		self._timeout_ms = timeout * 1000.0
		self._on_timeout = on_done
		self._cb_data = cb_data
		self._repeat = repeat
		self._time = 0

	def entityType(self):
		return Entity.TIMER_TYPE


	def categories(self):
		return ()


	def update(self, t, dt):
		self._time += dt
		if self._time > self._timeout_ms:
			return self._action
		else:
			return None


	def _action(self):
		self._on_timeout(self, self._cb_data)
		if self._repeat:
			self._time -= self._timeout_ms
		else:
			self.destroy()
